#include <os.h>
#include <nspireio.h>
#include "misc.h"
#include "syscalls.h"
#include "list.h"
#include "task.h"


int main(void)
{
	void* pointer_list[100];
	
	task_list* t = create_task_list(pointer_list);
	
	do
	{
		memset(SCREEN_BASE_ADDRESS,0xBB,SCREEN_BYTES_SIZE);
		
		if(isKeyPressed(KEY_NSPIRE_1))
			refresh_task_list(t,pointer_list);
		
		int selection = update_list(t->list);
		if(selection != -1)
		{
			task* tsk = task_info(pointer_list[selection]);
			do
			{
				nio_grid_puts(0,0,0,0,"Task information",NIO_COLOR_WHITE,NIO_COLOR_BLACK);
				nio_grid_printf(0,0,0,1,NIO_COLOR_WHITE,NIO_COLOR_BLACK,"Name: %s",tsk->name);
				nio_grid_printf(0,0,0,2,NIO_COLOR_WHITE,NIO_COLOR_BLACK,"Status: %d (%s)",tsk->status,NU_STATUS[tsk->status]);
				nio_grid_printf(0,0,0,3,NIO_COLOR_WHITE,NIO_COLOR_BLACK,"Scheduled count: %d",tsk->scheduled_count);
				nio_grid_printf(0,0,0,4,NIO_COLOR_WHITE,NIO_COLOR_BLACK,"Priority: %d",tsk->priority);
				nio_grid_printf(0,0,0,5,NIO_COLOR_WHITE,NIO_COLOR_BLACK,"Preempt: %d (%s)",tsk->preempt,get_preempt(tsk->preempt));
				nio_grid_printf(0,0,0,6,NIO_COLOR_WHITE,NIO_COLOR_BLACK,"Time slice: %d",tsk->time_slice);
				nio_grid_printf(0,0,0,7,NIO_COLOR_WHITE,NIO_COLOR_BLACK,"Stack base: 0x%p",tsk->stack_base);
				nio_grid_printf(0,0,0,8,NIO_COLOR_WHITE,NIO_COLOR_BLACK,"Stack size: 0x%X",tsk->stack_size);
				nio_grid_printf(0,0,0,9,NIO_COLOR_WHITE,NIO_COLOR_BLACK,"Minimum stack: 0x%X",tsk->minimum_stack);
				
				nio_grid_puts(0,0,0,11,"[ESC] Back",NIO_COLOR_WHITE,NIO_COLOR_BLACK);
				nio_grid_puts(0,0,0,12,"[1] Terminate",NIO_COLOR_WHITE,NIO_COLOR_BLACK);
				
				wait_key_pressed();
				
				if(isKeyPressed(KEY_NSPIRE_1))
				{
					TCC_Terminate_Task(pointer_list[selection]);
					refresh_task_list(t,pointer_list);
					break;
				}
			} while(!isKeyPressed(KEY_NSPIRE_ESC));
			free(tsk);
			memset(SCREEN_BASE_ADDRESS,0xBB,SCREEN_BYTES_SIZE);
		}
		
		nio_grid_printf(0,0,0,0,NIO_COLOR_WHITE,NIO_COLOR_BLACK,"TI-Nspire Task Manager (%d tasks)",t->count);
		nio_grid_puts(0,0,0,1," Name        S Status            P",NIO_COLOR_WHITE,NIO_COLOR_BLACK);
		nio_grid_puts(0,0,0,29,"[1] Refresh [ENTER] Task info [ESC] Exit",NIO_COLOR_WHITE,NIO_COLOR_BLACK);
		draw_list(t->list);
		
		wait_key_pressed();
	} while(!isKeyPressed(KEY_NSPIRE_ESC));
	
	free_task_list(t);
	return 0;
}