#include "task.h"

const char NU_STATUS[13][20] = 
{
	"READY",
	"PURE_SUSPEND",
	"SLEEP_SUSPEND",
	"MAILBOX_SUSPEND",
	"QUEUE_SUSPEND",
	"PIPE_SUSPEND",
	"SEMAPHORE_SUSPEND",
	"EVENT_SUSPEND",
	"PARTITION_SUSPEND",
	"MEMORY_SUSPEND",
	"DRIVER_SUSPEND",
	"FINISHED",
	"TERMINATED"
};

const char yes[] = "Yes";
const char no[] = "No";

task* task_info(void* task_ptr)
{
	task* t = malloc(sizeof(task));
	memset(t->name,0,10);
	t->task_ptr = task_ptr;
	TCF_Task_Information(task_ptr,t->name,&t->status,&t->scheduled_count,&t->priority,&t->preempt,&t->time_slice,&t->stack_base,&t->stack_size,&t->minimum_stack);
	
	return t;
}

const char* get_preempt(int preempt)
{
	if(preempt == 10)
		return yes;
	else
		return no;
}

entry* create_entries(void* pointer_list[], unsigned count)
{
	entry* e = malloc(count*sizeof(entry));
	
	unsigned i;
	for(i = 0; i < count; i++)
	{
		task* t = task_info(pointer_list[i]);
		sprintf(e[i].text,"%-10s %2d %-17s %d",t->name,t->status,NU_STATUS[t->status],t->priority);
		free(t);
	}
	
	return e;
}

task_list* create_task_list(void* pointer_list[])
{
	task_list* t = malloc(sizeof(task_list));
	t->count = TCF_Task_Pointers(pointer_list,100);
	t->entries = create_entries(pointer_list,t->count);
	t->list = create_list(0,16,27,t->entries,t->count);
	
	return t;
}

void free_task_list(task_list* t)
{
	free(t->entries);
	free(t->list);
	free(t);
}

void refresh_task_list(task_list* t, void* pointer_list[])
{
	free_task_list(t);
	t = create_task_list(pointer_list);
}