#include <os.h>
#include <nspireio.h>
#include "syscalls.h"
#include "list.h"

#ifndef TASK_H
#define TASK_H

extern const char NU_STATUS[13][20];

typedef struct task
{
	void* task_ptr;
	char name[10];
	unsigned char status;
	unsigned int scheduled_count;
	unsigned char priority;
	unsigned char preempt;
	unsigned int time_slice;
	void* stack_base;
	unsigned int stack_size;
	unsigned int minimum_stack;
} task;

typedef struct task_list
{
	entry* entries;
	list* list;
	unsigned count;
} task_list;

task* task_info(void* task_ptr);
const char* get_preempt(int preempt);
entry* create_entries(void* pointer_list[], unsigned count);
task_list* create_task_list(void* pointer_list[]);
void free_task_list(task_list* t);
void refresh_task_list(task_list* t, void* pointer_list[]);

#endif